# Module: `wibox.layout.ratio`

A layout filling all the available space.

Each widget is assigned a ratio (percentage) of the total space. Multiple methods are available to adjust this ratio.

### Usage:

    local w = wibox.widget {
        generic_widget( "first"  ),
        generic_widget( "second" ),
        generic_widget( "third"  ),
        layout  = wibox.layout.ratio.horizontal
    }
    w:adjust_ratio(2, 0.44, 0.33, 0.22)

### Class Hierarchy

- gears.object
- - wibox.widget.base
  - - wibox.layout.fixed
    - - wibox.layout.flex
      - - wibox.layout.ratio

### Info:

- Copyright: 2016 Emmanuel Lepage Vallee
- Originally authored by: Emmanuel Lepage Vallee
  (Full contributors list available on our github project)

### See also:

03-declarative-layout.md

## Constructors

wibox.layout.ratio.horizontal (...) | Returns a new horizontal ratio layout. |
wibox.layout.ratio.vertical (...) | Returns a new vertical ratio layout. |

## Object properties

spacing_widget | widget or nil | The widget used to fill the spacing between the layout elements. |
spacing | number | Add spacing between each layout widgets. |
inner_fill_strategy | string | Set how the space of invisible or `0x0` sized widget is redistributed. |
max_widget_size | number or nil | Set the maximum size the widgets in this layout will take. | Inherited from wibox.layout.flex
children | table | Get or set the children elements. | Inherited from wibox.widget.base
all_children | table | Get all direct and indirect children widgets. | Inherited from wibox.widget.base
forced_height | number or nil | Force a widget height. | Inherited from wibox.widget.base
forced_width | number or nil | Force a widget width. | Inherited from wibox.widget.base
opacity | number | The widget opacity (transparency). | Inherited from wibox.widget.base
visible | boolean | The widget visibility. | Inherited from wibox.widget.base
buttons | table | The widget buttons. | Inherited from wibox.widget.base

## Object methods

:inc_ratio (index, increment) | Increase the ratio of "widget". |
:inc_widget_ratio (widget, increment) | Increment the ratio of the first instance of `widget`. |
:set_ratio (index, percent) | Set the ratio of the widget at position `index`. |
:get_ratio (index) -> number | Get the ratio at `index`. |
:set_widget_ratio (widget, percent) | Set the ratio of `widget` to `percent`. |
:adjust_ratio (index, before, itself, after) | Update all widgets to match a set of a ratio. |
:adjust_widget_ratio (widget, before, itself, after) | Update all widgets to match a set of a ratio. |
:add (...) | Add some widgets to the given fixed layout. |
:remove (index) -> boolean | Remove a widget from the layout. |
:insert (index, widget) -> boolean | Insert a new widget in the layout at position `index`. |
:set (index, widget2) -> boolean | Set a widget at a specific index, replacing the current one. |
:replace_widget (widget, widget2, recursive) -> boolean | Replace the first instance of `widget` in the layout with `widget2`. |
:swap (index1, index2) -> boolean | Swap 2 widgets in a layout. |
:swap_widgets (widget1, widget2, recursive) -> boolean | Swap 2 widgets in a layout. |
:reset () | Reset the layout. |
:remove_widgets (...) -> boolean | Remove one or more widgets from the layout. | Inherited from wibox.layout.flex
:add_button (button) | Add a new awful.button to this widget. | Inherited from wibox.widget.base
:emit_signal_recursive (signal_name, ...) | Emit a signal and ensure all parent widgets in the hierarchies also forward the signal. | Inherited from wibox.widget.base
:index (widget, recursive, ...) -> (number, widget, table) | Get the index of a widget. | Inherited from wibox.widget.base
:connect_signal (name, func) | Connect to a signal. | Inherited from gears.object
:weak_connect_signal (name, func) | Connect to a signal weakly. | Inherited from gears.object
:disconnect_signal (name, func) | Disconnect from a signal. | Inherited from gears.object
:emit_signal (name, ...) | Emit a signal. | Inherited from gears.object

## Deprecated functions

wibox.layout.ratio.ajust_ratio (index, before, itself, after) | Update all widgets to match a set of a ratio. | Deprecated
wibox.layout.ratio.ajust_widget_ratio (widget, before, itself, after) | Update all widgets to match a set of a ratio. | Deprecated

## Signals

widget::layout_changed | When the layout (size) change. | Inherited from wibox.widget.base
widget::redraw_needed | When the widget content changed. | Inherited from wibox.widget.base
button::press | When a mouse button is pressed over the widget. | Inherited from wibox.widget.base
button::release | When a mouse button is released over the widget. | Inherited from wibox.widget.base
mouse::enter | When the mouse enter a widget. | Inherited from wibox.widget.base
mouse::leave | When the mouse leave a widget. | Inherited from wibox.widget.base

## Constructors

🔗 wibox.layout.ratio.horizontal (...)
  Returns a new horizontal ratio layout. A ratio layout shares the available space. equally among all widgets. Widgets can be added via :add(widget).

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  ... |  | widget | Widgets that should be added to the layout.

🔗 wibox.layout.ratio.vertical (...)
  Returns a new vertical ratio layout. A ratio layout shares the available space. equally among all widgets. Widgets can be added via :add(widget).

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  ... |  | widget | Widgets that should be added to the layout.

## Object properties

🔗 spacing_widget widget or nil · 1 signal
  The widget used to fill the spacing between the layout elements.

  By default, no widget is used.

  ### Constraints:

  Default value | : `nil`

  ### Usage:

      -- Use the separator widget directly
      local w1 = wibox.widget {
          spacing        = 10,
          spacing_widget = wibox.widget.separator,
          layout         = wibox.layout.ratio.horizontal
      }

      -- Use a standard declarative widget construct
      local w2 = wibox.widget {
          spacing = 10,
          spacing_widget = {
              color  = "#00ff00",
              shape  = gears.shape.circle,
              widget = wibox.widget.separator,
          },
          layout = wibox.layout.ratio.horizontal
      }

      -- Use composed widgets
      local w3 = wibox.widget {
          spacing = 10,
          spacing_widget = {
              {
                  text   = "F",
                  widget = wibox.widget.textbox,
              },
              bg     = "#ff0000",
              widget = wibox.container.background,
          },
          layout = wibox.layout.ratio.horizontal
      }

      -- Use negative spacing to create a powerline effect
      local w4 = wibox.widget {
          spacing = -12,
          spacing_widget = {
              color  = "#ff0000",
              shape  = gears.shape.powerline,
              widget = wibox.widget.separator,
          },
          layout = wibox.layout.ratio.horizontal
      }

  Click to display more

  ### Emit signals:

  - `property::spacing_widget` When the spacing_widget value changes.
  - `self` wibox.layout.ratio The object which changed (useful when connecting many object to the same callback).
  - `new_value` spacing_widget The new value affected to the property.
🔗 spacing number · 1 signal
  Add spacing between each layout widgets.

  ### Constraints:

  Default value | : `0`
  Negative allowed | : true

  ### Usage:

      for i=1, 5 do
          local w = wibox.widget {
              first,
              second,
              third,
              spacing = i*3,
              layout  = wibox.layout.ratio.horizontal
          }
      end

  Click to display more

  ### Emit signals:

  - `property::spacing` When the spacing value changes.
  - `self` wibox.layout.ratio The object which changed (useful when connecting many object to the same callback).
  - `new_value` spacing The new value affected to the property.
🔗 inner_fill_strategy string · 1 signal
  Set how the space of invisible or `0x0` sized widget is redistributed.

  ### Constraints:

  Default value | : `"default"`
  Valid values: | : One of the value listed above.
  `"default"` | : Honor the ratio and do not redistribute the space.
  `"justify"` | : Distribute the space among remaining widgets.
  `"center"` | : Squash remaining widgets and leave equal space on both side.
  `"inner_spacing"` | : Add equal spacing between all widgets.
  `"spacing"` | : Add equal spacing between all widgets and on the outside.
  `"left"` | : Squash remaining widgets and leave empty space on the left.
  `"right"` | : Squash remaining widgets and leave empty space on the right.

  Click to display more

  ### Emit signals:

  - `property::inner_fill_strategy` When the inner_fill_strategy value changes.
  - `self` wibox.layout.ratio The object which changed (useful when connecting many object to the same callback).
  - `new_value` inner_fill_strategy The new value affected to the property.
🔗 max_widget_size number or nil · Inherited from wibox.layout.flex · 1 signal
  Set the maximum size the widgets in this layout will take.

  That is, maximum width for horizontal and maximum height for vertical.

  ### Constraints:

  Default value | : `nil`
  Type description:
  nil | : No size limit.
  Negative allowed | : false

  Click to display more

  ### Emit signals:

  - `property::max_widget_size` When the `max_widget_size` value changes.
  - `self` wibox.layout.flex The object which changed (useful when connecting many object to the same callback).
  - `new_value` `max_widget_size` The new value affected to the property.
🔗 children table · Inherited from wibox.widget.base
  Get or set the children elements.

  ### Constraints:

  Default value | : `{}`
  Table content | : A list of wibox.widget.

  ### See also:

  wibox.widget.base.all_children |  |

🔗 all_children table · Inherited from wibox.widget.base
  Get all direct and indirect children widgets. This will scan all containers recursively to find widgets Warning: This method it prone to stack overflow if there is a loop in the widgets hierarchy. A hierarchy loop is when a widget, or any of its children, contain (directly or indirectly) itself.

  ### Constraints:

  Default value | : `{}`
  Table content | : A list of wibox.widget.

  ### See also:

  wibox.widget.base.children |  |

🔗 forced_height number or nil · Inherited from wibox.widget.base
  Force a widget height.

  ### Constraints:

  Default value | : `nil`
  Type description:
  nil | : Let the layout decide the height. Usually using the widget native height.
  number | : Enforce a number of pixels.
  Unit | : pixel
  Negative allowed | : false

  ### See also:

  wibox.widget.base.forced_width |  |

🔗 forced_width number or nil · Inherited from wibox.widget.base
  Force a widget width.

  ### Constraints:

  Default value | : `nil`
  Type description:
  nil | : Let the layout decide the width. Usually using the widget native width.
  number | : Enforce a number of pixels.
  Unit | : pixel
  Negative allowed | : false

  ### See also:

  wibox.widget.base.forced_height |  |

🔗 opacity number · Inherited from wibox.widget.base
  The widget opacity (transparency).

  ### Constraints:

  Default value | : `1.0`
  Unit | : A gradient between transparent (`0.0`) and opaque (`1.0`).
  Minimum value | : 0.0
  Maximum value | : 1.0

  ### See also:

  wibox.widget.base.visible |  |

🔗 visible boolean · Inherited from wibox.widget.base
  The widget visibility.

  ### Constraints:

  Default value | : `true`
  Valid values | : `true` or `false`.

  ### See also:

  wibox.widget.base.opacity |  |

🔗 buttons table · Inherited from wibox.widget.base
  The widget buttons.

  The table contains a list of awful.button objects.

  ### Constraints:

  Default value | : `{}`
  Table content | : A list of awful.button.

  ### See also:

  awful.button | Create easily new buttons objects ignoring certain modifiers. | module

## Object methods

🔗 :inc_ratio (index, increment)
  Increase the ratio of "widget". If the increment produce an invalid ratio (not between 0 and 1), the method do nothing.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  index |  | number | The widget index to change
  increment |  | number | An floating point value between -1 and 1 where the end result is within 0 and 1

  ### Usage:

      local ret = wibox.layout.fixed.vertical()
      local w = wibox.widget {
          first,
          second,
          third,
          layout  = wibox.layout.ratio.horizontal
      }
      for i=1, 5 do
          w:inc_ratio(2, 0.1)
      end

🔗 :inc_widget_ratio (widget, increment)
  Increment the ratio of the first instance of `widget`. If the increment produce an invalid ratio (not between 0 and 1), the method do nothing.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  widget |  | widget | The widget to adjust
  increment |  | number | An floating point value between -1 and 1 where the end result is within 0 and 1

🔗 :set_ratio (index, percent)
  Set the ratio of the widget at position `index`.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  index |  | number | The index of the widget to change
  percent |  | number | An floating point value between 0 and 1

🔗 :get_ratio (index) -> number
  Get the ratio at `index`.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  index |  | number | The widget index to query

  ### Returns:

  number The index (between 0 and 1)
🔗 :set_widget_ratio (widget, percent)
  Set the ratio of `widget` to `percent`.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  widget |  | widget | The widget to adjust.
  percent |  | number | A floating point value between 0 and 1.

🔗 :adjust_ratio (index, before, itself, after)
  Update all widgets to match a set of a ratio. The sum of before, itself and after must be 1 or nothing will be done.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  index |  | number | The index of the widget to change
  before |  | number | The sum of the ratio before the widget
  itself |  | number | The ratio for "widget"
  after |  | number | The sum of the ratio after the widget

  ### Usage:

      local ret = wibox.layout.fixed.vertical()
      local w = wibox.widget {
          first,
          second,
          third,
          layout  = wibox.layout.ratio.horizontal
      }
      local values = {
          {0.25, 0.50, 0.25},
          {0.33, 0.55, 0.12},
          {0.123, 0.456, 0.789},
          {0.123, 0, 0.789},
          {0, 1, 0},
      }
      for i=1, 5 do
          w:adjust_ratio(2, unpack(values[i]))
      end

🔗 :adjust_widget_ratio (widget, before, itself, after)
  Update all widgets to match a set of a ratio.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  widget |  | widget | The widget to adjust
  before |  | number | The sum of the ratio before the widget
  itself |  | number | The ratio for "widget"
  after |  | number | The sum of the ratio after the widget

🔗 :add (...) · 1 signal
  Add some widgets to the given fixed layout.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  ... |  | widget | Widgets that should be added (must at least be one)

  Click to display more

  ### Emit signals:

  - `widget::added` All new widgets are passed in the parameters.
  - `self` `widget` The layout.
🔗 :remove (index) -> boolean · 1 signal
  Remove a widget from the layout.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  index |  | number | The widget index to remove

  ### Returns:

  boolean index If the operation is successful
  Click to display more

  ### Emit signals:

  - `widget::removed`
  - `self` `widget` The fixed layout.
  - `widget` `widget` index The removed widget.
  - `index` `number` The removed index.
🔗 :insert (index, widget) -> boolean · 1 signal
  Insert a new widget in the layout at position `index`.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  index |  | number | The position.
  widget |  | widget | The widget.

  ### Returns:

  boolean `true` if the widget was inserted and `false` if the index is invalid.
  Click to display more

  ### Emit signals:

  - `widget::inserted`
  - `self` `widget` The ratio layout.
  - `widget` `widget` index The inserted widget.
  - `count` `number` The widget count.
🔗 :set (index, widget2) -> boolean · 1 signal
  Set a widget at a specific index, replacing the current one.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  index |  | number | A widget or a widget index
  widget2 |  | widget | The widget to replace the previous one with

  ### Returns:

  boolean Returns `true` if the widget was replaced successfully, `false` otherwise.
  Click to display more

  ### Emit signals:

  - `widget::replaced`
  - `self` `widget` The layout.
  - `widget` `widget` The inserted widget.
  - `previous` `widget` The previous widget.
  - `index` `number` The replaced index.
🔗 :replace_widget (widget, widget2, recursive) -> boolean · 1 signal
  Replace the first instance of `widget` in the layout with `widget2`.

  ### Parameters:

  Name |  | Type(s) | Description | Default value
  --- | --- | --- | --- | ---
  widget |  | widget | The widget to replace | Not applicable
  widget2 |  | widget | The widget to replace `widget` with | Not applicable
  recursive | Optional | boolean | Recurse into all compatible layouts to find the widget. | `false`

  ### Returns:

  boolean Returns `true` if the widget was replaced successfully, `false` otherwise.
  Click to display more

  ### Emit signals:

  - `widget::replaced`
  - `self` `widget` The layout.
  - `widget` `widget` index The inserted widget.
  - `previous` `widget` The previous widget.
  - `index` `number` The replaced index.
🔗 :swap (index1, index2) -> boolean · 1 signal
  Swap 2 widgets in a layout.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  index1 |  | number | The first widget index
  index2 |  | number | The second widget index

  ### Returns:

  boolean Returns `true` if the widget was replaced successfully, `false` otherwise.
  Click to display more

  ### Emit signals:

  - `widget::swapped`
  - `self` `widget` The layout.
  - `widget1` `widget` The first widget.
  - `widget2` `widget` The second widget.
  - `index1` `number` The first index.
  - `index1` `number` The second index.
🔗 :swap_widgets (widget1, widget2, recursive) -> boolean · 1 signal
  Swap 2 widgets in a layout.

  If `widget1` is present multiple time, only the first instance is swapped.

  Calls set internally, so the signal `widget::replaced` is emitted for both widgets as well.

  ### Parameters:

  Name |  | Type(s) | Description | Default value
  --- | --- | --- | --- | ---
  widget1 |  | widget | The first widget | Not applicable
  widget2 |  | widget | The second widget | Not applicable
  recursive | Optional | boolean | Recurse into all compatible layouts to find the widget. | `false`

  ### Returns:

  boolean Returns `true` if the widget was replaced successfully, `false` otherwise.

  ### See also:

  set | Set a widget at a specific index, replacing the current one. | object methods

  Click to display more

  ### Emit signals:

  - `widget::swapped`
  - `self` `widget` The layout.
  - `widget1` `widget` The first widget.
  - `widget2` `widget` The second widget.
  - `index1` `number` The first index.
  - `index1` `number` The second index.
🔗 :reset () · 1 signal
  Reset the layout. This removes all widgets from the layout.
  Click to display more

  ### Emit signals:

  - `widget::reset`
  - `self` `widget` The layout.
🔗 :remove_widgets (...) -> boolean · Inherited from wibox.layout.flex
  Remove one or more widgets from the layout.

  The last parameter can be a boolean, forcing a recursive seach of the widget(s) to remove.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  ... |  | widget | Widgets that should be removed (must at least be one).

  ### Returns:

  boolean If the operation is successful.
🔗 :add_button (button) · Inherited from wibox.widget.base
  Add a new awful.button to this widget.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  button |  | awful.button | The button to add.

🔗 :emit_signal_recursive (signal_name, ...) · Inherited from wibox.widget.base
  Emit a signal and ensure all parent widgets in the hierarchies also forward the signal.

  This is useful to track signals when there is a dynamic set of containers and layouts wrapping the widget.

  Note that this function has some flaws:

  1. The signal is only forwarded once the widget tree has been built. This happens after all currently scheduled functions have been executed. Therefore, it will not start to work right away. 2. In case the widget is present multiple times in a single widget tree, this function will also forward the signal multiple times (once per upward tree path). 3. If the widget is removed from the widget tree, the signal is still forwarded for some time, similar to the first case.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  signal_name |  | string |
  ... |  |  | Other arguments

🔗 :index (widget, recursive, ...) -> (number, widget, table) · Inherited from wibox.widget.base
  Get the index of a widget.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  widget |  | widget | The widget to look for.
  recursive | Optional | boolean | Recursively check accross the sub-widgets hierarchy.
  ... | Optional | widget | Additional widgets to add at the end of the sub-widgets hierarchy "path".

  ### Returns:

  1. number The widget index.
  2. widget The parent widget.
  3. table The hierarchy path between "self" and "widget".
🔗 :connect_signal (name, func) · Inherited from gears.object
  Connect to a signal.

  **Usage example output**:

  In slot [obj] nil nil nil In slot [obj] foo bar 42

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  name |  | string | The name of the signal.
  func |  | function | The callback to call when the signal is emitted.

  ### Usage:

      local o = gears.object{}
      -- Function can be attached to signals
      local function slot(obj, a, b, c)
          print("In slot", obj, a, b, c)
      end
      o:connect_signal("my_signal", slot)
      -- Emitting can be done without arguments. In that case, the object will be
      -- implicitly added as an argument.
      o:emit_signal "my_signal"
      -- It is also possible to add as many random arguments are required.
      o:emit_signal("my_signal", "foo", "bar", 42)
      -- Finally, to allow the object to be garbage collected (the memory freed), it
      -- is necessary to disconnect the signal or use weak_connect_signal
      o:disconnect_signal("my_signal", slot)
      -- This time, the slot wont be called as it is no longer connected.
      o:emit_signal "my_signal"

🔗 :weak_connect_signal (name, func) · Inherited from gears.object
  Connect to a signal weakly.

  This allows the callback function to be garbage collected and automatically disconnects the signal when that happens. **Warning:** Only use this function if you really, really, really know what you are doing.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  name |  | string | The name of the signal.
  func |  | function | The callback to call when the signal is emitted.

🔗 :disconnect_signal (name, func) · Inherited from gears.object
  Disconnect from a signal.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  name |  | string | The name of the signal.
  func |  | function | The callback that should be disconnected.

🔗 :emit_signal (name, ...) · Inherited from gears.object
  Emit a signal.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  name |  | string | The name of the signal
  ... |  |  | Extra arguments for the callback functions. Each connected function receives the object as first argument and then any extra arguments that are given to emit_signal()

## Deprecated functions

🔗 wibox.layout.ratio.ajust_ratio (index, before, itself, after)
  Update all widgets to match a set of a ratio.

  This method is kept for backwards compatibility, please use `:adjust_ratio` instead.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  index |  | number | The index of the widget to change
  before |  | number | The sum of the ratio before the widget
  itself |  | number | The ratio for "widget"
  after |  | number | The sum of the ratio after the widget

  ### See also:

  wibox.layout.ratio.adjust_ratio | Update all widgets to match a set of a ratio. | object methods

🔗 wibox.layout.ratio.ajust_widget_ratio (widget, before, itself, after)
  Update all widgets to match a set of a ratio.

  This method is kept for backwards compatibility, please use `:adjust_widget_ratio` instead.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  widget |  | widget | The widget to adjust
  before |  | number | The sum of the ratio before the widget
  itself |  | number | The ratio for "widget"
  after |  | number | The sum of the ratio after the widget

  ### See also:

  wibox.layout.ratio.adjust_widget_ratio | Update all widgets to match a set of a ratio. | object methods

## Signals

🔗 widget::layout_changed · Inherited from wibox.widget.base
  When the layout (size) change. This signal is emitted when the previous results of `:layout()` and `:fit()` are no longer valid. Unless this signal is emitted, `:layout()` and `:fit()` must return the same result when called with the same arguments.

  ### See also:

  widget::redraw_needed | When the widget content changed. | signals

🔗 widget::redraw_needed · Inherited from wibox.widget.base
  When the widget content changed. This signal is emitted when the content of the widget changes. The widget will be redrawn, it is not re-layouted. Put differently, it is assumed that `:layout()` and `:fit()` would still return the same results as before.

  ### See also:

  widget::layout_changed | When the layout (size) change. | signals

🔗 button::press · Inherited from wibox.widget.base
  When a mouse button is pressed over the widget.

  ### Arguments:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  self |  | table | The current object instance itself.
  lx |  | number | The horizontal position relative to the (0,0) position in the widget.
  ly |  | number | The vertical position relative to the (0,0) position in the widget.
  button |  | number | The button number.
  mods |  | table | The modifiers (mod4, mod1 (alt), Control, Shift)
  find_widgets_result |  | table | The entry from the result of wibox:find_widgets for the position that the mouse hit.
  drawable |  | wibox.drawable | The drawable containing the widget.
  widget |  | widget | The widget being displayed.
  hierarchy |  | wibox.hierarchy | The hierarchy managing the widget's geometry.
  x |  | number | An approximation of the X position that the widget is visible at on the surface.
  y |  | number | An approximation of the Y position that the widget is visible at on the surface.
  width |  | number | An approximation of the width that the widget is visible at on the surface.
  height |  | number | An approximation of the height that the widget is visible at on the surface.
  widget_width |  | number | The exact width of the widget in its local coordinate system.
  widget_height |  | number | The exact height of the widget in its local coordinate system.

  ### See also:

  mouse | Manipulate and inspect the mouse cursor. | module

🔗 button::release · Inherited from wibox.widget.base
  When a mouse button is released over the widget.

  ### Arguments:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  self |  | table | The current object instance itself.
  lx |  | number | The horizontal position relative to the (0,0) position in the widget.
  ly |  | number | The vertical position relative to the (0,0) position in the widget.
  button |  | number | The button number.
  mods |  | table | The modifiers (mod4, mod1 (alt), Control, Shift)
  find_widgets_result |  | table | The entry from the result of wibox:find_widgets for the position that the mouse hit.
  drawable |  | wibox.drawable | The drawable containing the widget.
  widget |  | widget | The widget being displayed.
  hierarchy |  | wibox.hierarchy | The hierarchy managing the widget's geometry.
  x |  | number | An approximation of the X position that the widget is visible at on the surface.
  y |  | number | An approximation of the Y position that the widget is visible at on the surface.
  width |  | number | An approximation of the width that the widget is visible at on the surface.
  height |  | number | An approximation of the height that the widget is visible at on the surface.
  widget_width |  | number | The exact width of the widget in its local coordinate system.
  widget_height |  | number | The exact height of the widget in its local coordinate system.

  ### See also:

  mouse | Manipulate and inspect the mouse cursor. | module

🔗 mouse::enter · Inherited from wibox.widget.base
  When the mouse enter a widget.

  ### Arguments:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  self |  | table | The current object instance itself.
  find_widgets_result |  | table | The entry from the result of wibox:find_widgets for the position that the mouse hit.
  drawable |  | wibox.drawable | The drawable containing the widget.
  widget |  | widget | The widget being displayed.
  hierarchy |  | wibox.hierarchy | The hierarchy managing the widget's geometry.
  x |  | number | An approximation of the X position that the widget is visible at on the surface.
  y |  | number | An approximation of the Y position that the widget is visible at on the surface.
  width |  | number | An approximation of the width that the widget is visible at on the surface.
  height |  | number | An approximation of the height that the widget is visible at on the surface.
  widget_width |  | number | The exact width of the widget in its local coordinate system.
  widget_height |  | number | The exact height of the widget in its local coordinate system.

  ### See also:

  mouse | Manipulate and inspect the mouse cursor. | module

🔗 mouse::leave · Inherited from wibox.widget.base
  When the mouse leave a widget.

  ### Arguments:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  self |  | table | The current object instance itself.
  find_widgets_result |  | table | The entry from the result of wibox:find_widgets for the position that the mouse hit.
  drawable |  | wibox.drawable | The drawable containing the widget.
  widget |  | widget | The widget being displayed.
  hierarchy |  | wibox.hierarchy | The hierarchy managing the widget's geometry.
  x |  | number | An approximation of the X position that the widget is visible at on the surface.
  y |  | number | An approximation of the Y position that the widget is visible at on the surface.
  width |  | number | An approximation of the width that the widget is visible at on the surface.
  height |  | number | An approximation of the height that the widget is visible at on the surface.
  widget_width |  | number | The exact width of the widget in its local coordinate system.
  widget_height |  | number | The exact height of the widget in its local coordinate system.

  ### See also:

  mouse | Manipulate and inspect the mouse cursor. | module

generated by LDoc 1.5.0